if(!com) var com={};
if(!com.savard) com.savard={};
if(!com.savard.gmailadblocker) com.savard.gmailadblocker={};

com.savard.gmailadblocker = {
	yahooMainTab: null,
	prefManager: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.gmailadblocker."),
	mainGmailFrame: null,
	blockYahooAds: function(e) {
		var num = gBrowser.browsers.length;
		for (var i=0; i<num; i++) {
			var b = gBrowser.getBrowserAtIndex(i);
			if (b.contentDocument.location.href.match("mail.yahoo.")) {
				b.contentWindow.wrappedJSObject.JL.E = false;
				break;
			}
		}
	},
	detectTopRight: function(e) {
		var doc = com.savard.gmailadblocker.mainGmailFrame.contentDocument;
		var prefManager = com.savard.gmailadblocker.prefManager;
		var topRight = doc.getElementById("guser");
		if (topRight) {
			if (prefManager.getBoolPref("donateLink")) {
				var linkName = "Webmail Ad Blocker";
				var sep = topRight.innerHTML.indexOf("|");
				var linkNameIdx = topRight.innerHTML.indexOf(linkName);
				if (sep != -1 && linkNameIdx == -1) {
					topRight.innerHTML = topRight.innerHTML.substring(0, sep) + " | <a target='_blank' href='http://mywebber.com/misc/addonsDonate.jsp' class='e' title='Please donate to the author of this addon!'>" + linkName + "</a> " + topRight.innerHTML.substring(sep);
				}
			}
			function getLayer(xpath) {
				var node = doc.evaluate(xpath, doc, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
				if (node) {
					return node.snapshotItem(0);
				}
			}
			function hideLayer(prefName, xpath) {
				if (prefManager.getBoolPref(prefName) == false) {
					var obj = getLayer(xpath);
					if (obj) {
						obj.style.display = 'none';
					}
				}
			}
			function hideMenuItem(prefName, str) {
				hideLayer(prefName, "//a[contains(@href, '#" + str + "')]//ancestor::div[contains(@class,'pX')]");
			}
			hideMenuItem("starredMenuItemOnLeft", "starred");
			hideMenuItem("allMail", "all");
			hideMenuItem("spam", "spam");
			hideMenuItem("trash", "trash");
			hideMenuItem("chats", "chats");
			if (prefManager.getBoolPref("spamCount") == false) {
				var obj = getLayer("//a[contains(@href, '#spam')]");
				if (obj) {
					obj.innerHTML = "Spam";
					obj.style.fontWeight = "normal";
				}
			}
		} else {
			setTimeout("com.savard.gmailadblocker.detectTopRight()", 1000);
		}
	},
	onPageLoad: function(e) {
		if (e.originalTarget instanceof HTMLDocument) {
			var doc = e.originalTarget;
			var prefManager = com.savard.gmailadblocker.prefManager;
			var css = "@namespace url(http://www.w3.org/1999/xhtml); ";
			var addCSS = false;

			if (doc.location.href.match("mail.google.")) {
				addCSS = true;
				var mainGmailFrame = doc.getElementById("canvas_frame");
				if (mainGmailFrame) {
					com.savard.gmailadblocker.mainGmailFrame = mainGmailFrame;
					setTimeout("com.savard.gmailadblocker.detectTopRight()", 1000);
				}
				
				if (prefManager.getBoolPref("ads") == false) {
					var rightColumn =				" .T1HY1.nH.iY .tELAdc > .nH[style^='width: 225px'] ";
					var rightColumnNarrowBrowser =	" .T1HY1.nH.iY .tELAdc > .nH[style^='width: 189px'] ";

					var adArea = " .u5 {width:125px !important} ";
					var ads = " .u5 .oM {display:none} "
					var aboutTheseLinks = " .nH.u8 {display:none} ";
					var rightLinks = " .hk span {white-space:normal !important} ";

					css += rightColumn + "," + rightColumn + adArea;
					css += rightColumn + ads;
					css += rightColumn + aboutTheseLinks;
					css += rightColumn + rightLinks;

					css += rightColumnNarrowBrowser + "," + rightColumnNarrowBrowser + adArea;
					css += rightColumnNarrowBrowser + ads;
					css += rightColumnNarrowBrowser + aboutTheseLinks;
					css += rightColumnNarrowBrowser + rightLinks;
				}
				if (prefManager.getBoolPref("emailHighlighting")) {
					css += " .zA.yO:hover {background: rgb(255,235,134) none repeat scroll 0 0 !important} ";
					css += " .zA.zE:hover {background: rgb(205,243,159) none repeat scroll 0 0 !important} ";
				}
				if (prefManager.getBoolPref("stars") == false) {
					css += " .y5 {width:2px !important} ";
					css += " .cf.zt .y4 {visibility:hidden;width:1px} ";
				}
				if (prefManager.getBoolPref("chat") == false) {
					css += " .nH.s {display:none} ";
				}
				if (prefManager.getBoolPref("labelsOnLeft") == false) {
					css += " .nH.t {display:none} ";
				}
				if (prefManager.getBoolPref("invites") == false) {
					css += " .nH.pp.ps .nH.pY .nH.r, .nH.pp.ps .nH.pY .nH.pu {display:none} ";
					css += " .tELAdc:last-child .nH.pp.ps .nH.pY .nH.r, .tELAdc:last-child .nH.pp.ps .nH.pY .nH.pu {display:block} ";
				}
				if (prefManager.getBoolPref("selectAll") == false) {
					css += " .D.A1 .yV, .D.AY .yV {display:none} ";
				}
				if (prefManager.getBoolPref("checkBoxes") == false) {
					css += " .LcrgQc {width:2px !important} ";
					css += " .zdUBKd {display:none} ";
				}
				if (prefManager.getBoolPref("searchButtons") == false) {
					css += ".bN.bM, .bN.bR {display:none} ";
				}
				if (prefManager.getBoolPref("actionButtons") == false) {
					css += " .yCMBJb.S6g97b .sGcZQb {display:none} ";
					css += " .eeCDlc.goog-inline-block {display:none !important} ";
					css += " .AP {display:none} "; // Refresh link
				}
				if (prefManager.getBoolPref("currentEmailIndicator") == false) {
					css += " .TmhrL {visibility:hidden !important} ";
				}
				if (prefManager.getBoolPref("olderVersion") == false) {
					css += " #guser a[href='?ui=1'] {display:none} ";
				}
				if (prefManager.getBoolPref("tips") == false) {
					css += " .nH.l2.ov .mn {display:none} ";
				}
				if (prefManager.getBoolPref("currentlyUsing") == false) {
					css += " .nH.l2.ov .md {display:none} ";
				}
				if (prefManager.getBoolPref("accountActivity") == false) {
					css += " .nH.l2.ov .l6 {display:none} ";
				}				
				if (prefManager.getBoolPref("gmailview") == false) {
					css += " .nH.l2.ov .mp {display:none} ";
				}
				if (prefManager.getBoolPref("copyright") == false) {
					css += " .nH.l2.ov .ma {display:none} ";
				}
			}

			if (doc.location.href.match("mail.live.")) {
				addCSS = true;
				if (prefManager.getBoolPref("hotmail.ads") == false) {
					css += " .Managed .WithSkyscraper #MainContent {right:0 !important} ";
					css += " #SkyscraperContent {display:none} ";
				}
			}

			if (doc.location.href.match("mail.yahoo.")) {
				addCSS = true;
				if (prefManager.getBoolPref("yahoo.ads") == false) {
					var num = gBrowser.browsers.length;
					var i;
					for (i=0; i<num; i++) {
						var b = gBrowser.getBrowserAtIndex(i);
						if (b.contentDocument.location.href.match("mail.yahoo.")) {

							setInterval("com.savard.gmailadblocker.blockYahooAds()", 200);

							var yahooMainTab = doc.getElementById("mainTabContainer");
							if (yahooMainTab) {
								com.savard.gmailadblocker.yahooMainTab = yahooMainTab;
							}
							if (com.savard.gmailadblocker.yahooMainTab) {
								if (com.savard.gmailadblocker.yahooMainTab.className.indexOf("TabItemActive") != -1) {
									b.contentWindow.wrappedJSObject.JL.E = true;
									b.contentWindow.wrappedJSObject.OU.F();
									b.contentWindow.wrappedJSObject.Oj();
								}
							}
							break;
						}
					}
					css += " #welcomeAdsContainer {display:none !important} ";
					css += " #nwPane {visibility:hidden !important} ";
					css += " #swPane {display:none !important} ";
					css += " #largePane {display:none !important} ";
					css += " .ad_slug_table {display:none !important} ";
				}
			}

			if (addCSS) {
				var heads = doc.getElementsByTagName("head");
				if (heads.length > 0) {
					var node = doc.createElement("style");
					node.type = "text/css";
					node.appendChild(doc.createTextNode(css));
					heads[0].appendChild(node);
				}
			}
		}
	}
}

addEventListener("DOMContentLoaded", com.savard.gmailadblocker.onPageLoad, true);